/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *
 *  TOPPERS/JSP for Blackfin
 *
 *  Copyright (C) 2004,2006,2006 by Takemasa Nakamura
 *  Copyright (C) 2004 by Ujinosuke
 *
 *  上記著作権者は，以下の (1)〜(4) の条件か，Free Software Foundation
 *  によって公表されている GNU General Public License の Version 2 に記
 *  述されている条件を満たす場合に限り，本ソフトウェア（本ソフトウェア
 *  を改変したものを含む．以下同じ）を使用・複製・改変・再配布（以下，
 *  利用と呼ぶ）することを無償で許諾する．
 *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
 *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
 *      スコード中に含まれていること．
 *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
 *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
 *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
 *      の無保証規定を掲載すること．
 *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
 *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
 *      と．
 *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
 *        作権表示，この利用条件および下記の無保証規定を掲載すること．
 *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
 *        報告すること．
 *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
 *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
 *
 *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
 *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，その適用可能性も
 *  含めて，いかなる保証も行わない．また，本ソフトウェアの利用により直
 *  接的または間接的に生じたいかなる損害に関しても，その責任を負わない．
 *
 *
 */



/*
 *	プロセッサ依存モジュール（BLACKfin用）
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"

/*
* イベントハンドラの入り口で保存するFPの格納変数
*/
VP event_fp;

/*
 * GDBでデバッグ時にブートを行うかどうか制御する変数
 * 通常は偽なので、ロード後、gdbで1に修正して使う
 */
#ifdef __GNUC__
unsigned int enable_boot_for_gdb  __attribute__((section(".data"), used)) = 0;
#elif defined(__ECC__)
#else
#error "Compiler is not supported"
#endif

static void dummy_exception_handler(VP exc_info);
void (* exc_vector)(VP) = &dummy_exception_handler;
void (* dev_vector[DEVICE_INTERRUPT_COUNT+3])(void) ;


static void dummy_interrupt_handler(void)
{
	while(1)
		;
}

static void dummy_exception_handler(VP exc_info)
{
	while(1)
		;
}


/*
 *  プロセッサ依存の初期化
 */
void
cpu_initialize()
{
	int i;

	for ( i=0; i<DEVICE_INTERRUPT_COUNT+3; i++ )
		dev_vector[i] = &dummy_interrupt_handler;
}

/*
 *  プロセッサ依存の終了処理
 */
void
cpu_terminate()
{
	*__pIMASK = 0;		/* 割り込み禁止 */
}


